//
//  HTRingBuffer.h - utility that provides a "ring buffer"
//
//  Created by Cameron Hayne on Tue Aug 19 2003.
//  Copyright 2006 Hayne of Tintagel.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#import <Foundation/Foundation.h>

@interface HTRingBuffer : NSObject
{
    NSMutableArray  *myObjects;
    unsigned         myCapacity;
    unsigned         myCurrentIndex;
}

- (id)initWithCapacity:(unsigned)maxItems;
- (void)setCapacity:(unsigned)maxItems;
- (unsigned)capacity;
- (unsigned)count;
- (void)addObject:(id)object;
- (id)firstObject;
- (id)lastObject;
- (id)objectAtIndex:(unsigned)index;
- (void)setCurrentIndex:(unsigned)index;
- (void)setCurrentIndexToNone;
- (void)setCurrentIndexToLast;
- (void)setCurrentIndexToPrevious;
- (void)setCurrentIndexToNext;
- (void)setCurrentIndexBackBy:(int)num;
- (void)setCurrentIndexForwardBy:(int)num;
- (id)currentObject;
- (id)previousObject;

@end
