//
//  Info.h - one item in the history list (has info on system, program, allocs)
//  VMTester
//
//  Created by Cameron Hayne on 20/02/05.
//  Copyright 2006 Hayne of Tintagel.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#import <Cocoa/Cocoa.h>
#import "SysInfo.h"
#import "ProgInfo.h"

@interface Info : NSObject
{
    NSCalendarDate *myDate;
    SysInfo        *mySysInfo;
    ProgInfo       *myProgInfo;
    NSArray        *myAllocations;
}

- (id)initWithAllocations:(NSArray *)allocInfoArray;

- (NSString *)dateString;
- (NSTimeInterval)dateInEpochSec;
- (SysInfo *)sysInfo;
- (ProgInfo *)progInfo;
- (NSArray *)allocations;

@end
