//
//  MyController.h - the core of the program
//  VMTester
//
//  Created by Cameron Hayne on 28/11/04.
//  Copyright 2006 Hayne of Tintagel.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#import <Cocoa/Cocoa.h>
#import "HTRingBuffer.h"
#import "Allocations.h"
#import "Info.h"
#import "SysInfoCtr.h"
#import "ProgInfoCtr.h"
#import "AllocInfoCtr.h"

@interface MyController : NSObject
{
    // main window outlets
    IBOutlet id myWindow;
    IBOutlet id myDateTimeLbl;
    IBOutlet id myAutoUpdateBtn;
    IBOutlet id mySysInfoTbl;
    IBOutlet id myConsolidateBtn;
    IBOutlet id myResetPageInsOutsBtn;
    IBOutlet id myProgInfoTbl;
    IBOutlet id myMemAllocTbl;
    IBOutlet id myTotalMemAllocLbl;
    IBOutlet id myDeAllocateSelectedBtn;
    IBOutlet id myDeAllocateAllBtn;
    IBOutlet id myAllocAmountTxf;
    IBOutlet id myAllocAmountFmt;
    IBOutlet id myAllocateBtn;
    IBOutlet id myAllocateAndUseBtn;
    // consolidate sheet outlets
    IBOutlet id myConsolidateSheet;
    IBOutlet id myConsolidateCmdTxf;
    IBOutlet id myConsolidateOkBtn;
    
    BOOL              myAutoUpdate;
    NSColor          *myHistoryColour;
    Allocations      *myAllocations;
    HTRingBuffer     *myHistory;
    SysInfoCtr       *mySysInfoCtr;
    ProgInfoCtr      *myProgInfoCtr;
    AllocInfoCtr     *myAllocInfoCtr;
    NSTask           *myConsolidationTask;
    int               myMaxHistoryItems;
    float             myUpdatePeriod;
    float             myMemoryReadPeriod;
}

- (IBAction)turnOnAutoUpdate:(id)sender;
- (IBAction)showPreviousInfo:(id)sender;
- (IBAction)showNextInfo:(id)sender;
- (IBAction)resetPageInsOutsAction:(id)sender;
- (IBAction)deallocateSelectedAction:(id)sender;
- (IBAction)deallocateAllAction:(id)sender;
- (IBAction)allocateAction:(id)sender;
- (IBAction)allocateAndUseAction:(id)sender;
- (IBAction)exportAction:(id)sender;
- (IBAction)openConsolidateSheet:(id)sender;
- (IBAction)closeConsolidateSheet:(id)sender;

@end
